// Pencil Sketch 7 -- 3 Drawings
// by John Clavin June 2015
// The computer Draws its Master
// Production Version 1
Pencil[] pencils;
int[][] earsData = new int[700][2];
int[][] faceData = new int[14000][2];
int[][] eyeSData = new int[100][2];
int[][] eyeData = new int[200][2];
int[][] eyeBData = new int[300][2]; 
int[][] noseData = new int[700][2];
int[][] nostData = new int[100][2];
int[][] mouthData = new int[100][2];
int[][] neckData = new int[320][2];
int[][] hairData = new int[2750][2];
int numberOfPencils;
PGraphics pg;
int location1;
int location2;
int location3;

void setup() {
  size(970, 350);
  background(248);
  noFill();
  smooth();
  strokeWeight(1);
  frameRate(12);
  pg = createGraphics(500, 500);
  setupFace();
  parseFaceData();
  location1 = 0;
  location2 = 420;
  location3 = 840;
  numberOfPencils = 180;
  pencils = new Pencil[numberOfPencils];
  for (int i = 0; i < 60; i++) {
    pencils[i] = new Pencil((int)random(10), location1);
  }
  for (int i = 60; i < 120; i++) {
    pencils[i] = new Pencil((int)random(10), location2);
  }
  for (int i = 120; i < numberOfPencils; i++) {
    pencils[i] = new Pencil((int)random(10), location3);
  }
}

void draw() {
  scale(0.74); // 945 total width
  for (int i = 0; i < numberOfPencils; i++) {
    pencils[i].adumbrate();
  }
}

void parseFaceData() {
  color data;
  int redLevel;
  int earsIndex = 0;
  int faceIndex = 0;
  int eyeSIndex = 0;
  int eyeIndex = 0;
  int eyeBIndex = 0;
  int noseIndex = 0;
  int nostIndex = 0;
  int mouthIndex = 0;
  int neckIndex = 0;
  int hairIndex = 0;
  for (int y = 0; y < 500; y = y + 2) {
    for (int x = 0; x < 500; x = x + 2) {
      data = pg.get(x, y);
      redLevel = (int)red(data);
      if (redLevel != 255) {
        if (redLevel == 140) {
          earsData[earsIndex][0] = x;
          earsData[earsIndex][1] = y;
          earsIndex++;
        } else if (redLevel == 150) {
          faceData[faceIndex][0] = x;
          faceData[faceIndex][1] = y;
          faceIndex++;
        } else if (redLevel == 160) {
          eyeSData[eyeSIndex][0] = x;
          eyeSData[eyeSIndex][1] = y;
          eyeSIndex++;
        } else if (redLevel == 170) {
          eyeData[eyeIndex][0] = x;
          eyeData[eyeIndex][1] = y;
          eyeIndex++;
        } else if (redLevel == 180) {
          eyeBData[eyeBIndex][0] = x;
          eyeBData[eyeBIndex][1] = y;
          eyeBIndex++;
        } else if (redLevel == 200) {
          noseData[noseIndex][0] = x;
          noseData[noseIndex][1] = y;
          noseIndex++;
        } else if (redLevel == 210) {
          nostData[nostIndex][0] = x;
          nostData[nostIndex][1] = y;
          nostIndex++;
        } else if (redLevel == 220) {
          mouthData[mouthIndex][0] = x;
          mouthData[mouthIndex][1] = y;
          mouthIndex++;
        } else if (redLevel == 230) {
          neckData[neckIndex][0] = x;
          neckData[neckIndex][1] = y;
          neckIndex++;
        } else if (redLevel == 240) {
          hairData[hairIndex][0] = x;
          hairData[hairIndex][1] = y;
          hairIndex++;
        }
      }
    }
  }
}

class Pencil {
  int stopCount;
  int dSwitchCount;
  int pSwitchCount;
  int faceElement;
  int xPosition, yPosition;
  int xPosOffset;
  int numPoints = 16;
  float radius, angle;
  int cA1, cA2, cA3, cA4; // curveAmount
  int circleSize1, circleSize2;
  int lowRadiusLimit, highRadiusLimit;
  int medLowRadiusLimit, medHighRadiusLimit;
  int shortLowRadiusLimit, shortHighRadiusLimit; 
  float segment1, segment2;
  float x1, y1, x2, y2;
  int angleIndex = 0;
  int angleIndexS = 0;

  Pencil(int element, int _xPosOffset) {
    xPosOffset = _xPosOffset;
    stopCount = 0;
    dSwitchCount = 0;
    pSwitchCount = 0;
    faceElement = element;
    getData(faceElement);
    parameterSet();
    angle = TWO_PI/float(numPoints);
  }

  void adumbrate() {
    if (faceElement == 0)
      drawEars();
    if (faceElement == 1)
      drawFace();
    if (faceElement == 2)
      drawEyeS();
    if (faceElement == 3)
      drawEye();
    if (faceElement == 4)
      drawEyeB();
    if (faceElement == 5)
      drawNose();
    if (faceElement == 6)
      drawNostril();
    if (faceElement == 7)
      drawMouth();
    if (faceElement == 8)
      drawNeck();
    if (faceElement == 9)
      drawHair();
  }

  void drawEars() {
    if (stopCount < 16) {
      if (pSwitchCount > 50) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 8) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_2();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawFace() {
    if (stopCount < 40) {
      if (pSwitchCount > 7) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 5) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_0();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawEyeS() {
    if (stopCount < 16) {
      if (pSwitchCount > 8) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 6) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_3();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawEye() {
    if (stopCount < 20) {
      if (pSwitchCount > 6) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 10) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_1();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawEyeB() {
    if (stopCount < 22) {
      if (pSwitchCount > 8) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 6) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_4();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawNose() {
    if (stopCount < 24) {
      if (pSwitchCount > 8) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 6) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_1();
      adumbrate_3();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }    
  void drawNostril() {
    if (stopCount < 12) {
      if (pSwitchCount > 6) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 4) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_3();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawMouth() {
    if (stopCount < 22) {
      if (pSwitchCount > 8) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 6) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_4();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawNeck() {
    if (stopCount < 10) {
      if (pSwitchCount > 5) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 4) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_2();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }
  void drawHair() {
    if (stopCount < 30) {
      if (pSwitchCount > 8) {
        parameterSet();
        pSwitchCount = 0;
      }
      if (dSwitchCount > 5) {
        getData(faceElement);
        dSwitchCount = 0;
      }
      adumbrate_2();
      stopCount++;
      pSwitchCount++;
      dSwitchCount++;
    }
  }    

  void adumbrate_0() {         // Big Circles
    noFill();
    cA2 = int(random(100, 200));
    cA3 = int(random(100, 200));
    radius = random(10, 30);
    segment1 = random(angle*angleIndex, angle*(angleIndex+1));
    x1 = radius*cos(segment1)+xPosition; 
    y1 = radius*sin(segment1)+yPosition;
    segment2 = random(angle*(angleIndex+8), angle*(angleIndex+9));
    x2 = radius*cos(segment2)+xPosition; 
    y2 = radius*sin(segment2)+yPosition;
    curve(x1+cA2, y1+cA2, x1, y1, x2, y2, x2+cA3, y2+cA3);
    curve(x1-cA2, y1-cA2, x1, y1, x2, y2, x2-cA3, y2-cA3);
    movePosition2();
  }

  void adumbrate_1() {         // Small Circles
    noFill();
    circleSize1 = int(random(4, 20)); // (4, 30)
    circleSize2 = int(random(4, 20)); // (4, 30)
    ellipse(xPosition, yPosition, circleSize1, circleSize2);
    movePosition2();
  }

  void adumbrate_2() {         // Long Lines
    noFill();
    radius = random(lowRadiusLimit, highRadiusLimit);
    segment1 = random(angle*angleIndex, angle*(angleIndex+1));
    x1 = radius*cos(segment1)+xPosition; 
    y1 = radius*sin(segment1)+yPosition;
    segment2 = random(angle*(angleIndex+8), angle*(angleIndex+9));
    x2 = radius*cos(segment2)+xPosition; 
    y2 = radius*sin(segment2)+yPosition;
    curve(x1+cA1, y1+cA1, x1, y1, x2, y2, x2+cA1, y2+cA1);
    movePosition2();
  }

  void adumbrate_3() {         // short Lines
    noFill();
    cA4 = int(random(5, 30));
    radius = random(shortLowRadiusLimit, shortHighRadiusLimit);
    segment1 = random(angle*angleIndex, angle*(angleIndex+1));
    x1 = radius*cos(segment1)+xPosition; 
    y1 = radius*sin(segment1)+yPosition;
    segment2 = random(angle*(angleIndex+8), angle*(angleIndex+9));
    x2 = radius*cos(segment2)+xPosition; 
    y2 = radius*sin(segment2)+yPosition;
    curve(x1+cA4, y1+cA4, x1, y1, x2, y2, x2+cA4, y2+cA4);
    movePosition1();
  }

  void adumbrate_4() {         // Medium Lines
    noFill();
    angleIndexS = int(random(5, 10));
    cA4 = int(random(6, 40));
    radius = random(shortLowRadiusLimit, shortHighRadiusLimit);
    segment1 = random(angle*angleIndexS, angle*(angleIndexS+1));
    x1 = radius*cos(segment1)+xPosition; 
    y1 = radius*sin(segment1)+yPosition;
    segment2 = random(angle*(angleIndexS+8), angle*(angleIndexS+9));
    x2 = radius*cos(segment2)+xPosition; 
    y2 = radius*sin(segment2)+yPosition;
    curve(x1+cA4, y1+cA4, x1, y1, x2, y2, x2+cA4, y2+cA4);
    movePosition1a();
  }

  void getData(int type) {
    int dataType = type;
    int rndData;
    if (dataType == 0) {  // Ears
      rndData = (int)random(640);
      xPosition = earsData[rndData][0];
      yPosition = earsData[rndData][1];
    } else if (dataType == 1) {  // Face
      rndData = (int)random(13030);
      xPosition = faceData[rndData][0];
      yPosition = faceData[rndData][1];
    } else if (dataType == 2) {  // EyeS
      rndData = (int)random(64);
      xPosition = eyeSData[rndData][0];
      yPosition = eyeSData[rndData][1];
    } else if (dataType == 3) {  // Eyes
      rndData = (int)random(140);
      xPosition = eyeData[rndData][0];
      yPosition = eyeData[rndData][1];
    } else if (dataType == 4) {  // EyeB
      rndData = (int)random(240);
      xPosition = eyeBData[rndData][0];
      yPosition = eyeBData[rndData][1];
    } else if (dataType == 5) {  // Nose
      rndData = (int)random(600);
      xPosition = noseData[rndData][0];
      yPosition = noseData[rndData][1];
    } else if (dataType == 6) {  // Nostril
      rndData = (int)random(40);
      xPosition = nostData[rndData][0];
      yPosition = nostData[rndData][1];
    } else if (dataType == 7) {  // Mouth
      rndData = (int)random(80);
      xPosition = mouthData[rndData][0];
      yPosition = mouthData[rndData][1];
    } else if (dataType == 8) {  // Neck
      rndData = (int)random(200);
      xPosition = neckData[rndData][0];
      yPosition = neckData[rndData][1];
    } else if (dataType == 9) {  // Hair
      rndData = (int)random(2690);
      xPosition = hairData[rndData][0];
      yPosition = hairData[rndData][1];
    }
    xPosition = xPosition + xPosOffset;
  }

  void movePosition1a() {
    xPosition += int(random(-4, 4));
    yPosition += int(random(-2, 3));
  }

  void movePosition1() {
    xPosition += int(random(-3, 3));
    yPosition += int(random(-3, 3));
  }

  void movePosition2() {
    xPosition += int(random(-6, 6));
    yPosition += int(random(-6, 6));
  }

  void movePosition3() {
    xPosition += int(random(-10, 10));
    yPosition += int(random(-10, 10));
  }

  void parameterSet() {
    cA1 = int(random(20, 70));
    angleIndex = int(random(3, 8));
    stroke(int(random(30, 100)), 80);
    lowRadiusLimit = int(random(10, 20));
    highRadiusLimit = int(random(15, 100));
    medLowRadiusLimit = int(random(6, 16));
    medHighRadiusLimit = int(random(16, 46));
    shortLowRadiusLimit = int(random(2, 12));
    shortHighRadiusLimit = int(random(12, 20));
  }
}

void setupFace() {
  pg.beginDraw();
  pg.background(255);
  pg.rectMode(CENTER);
  pg.noStroke();

  pg.fill(140); // Ears
  pg.ellipse(120, 235, 30, 100);
  pg.ellipse(380, 235, 30, 100);

  pg.fill(150);    // Face
  pg.ellipse(250, 220, 260, 340);

  pg.fill(160); // Eyes Sockets
  pg.ellipse(200, 180, 60, 40);
  pg.ellipse(300, 180, 60, 40);
  pg.fill(255); // Eyes Whites
  pg.ellipse(200, 180, 56, 36);
  pg.ellipse(300, 180, 56, 36);

  pg.fill(170); // Eyes
  pg.ellipse(200, 180, 20, 20);
  pg.ellipse(300, 180, 20, 20);

  pg.fill(180); // Eye Brows
  pg.rect(200, 160, 60, 8);
  pg.rect(300, 160, 60, 8);

  pg.fill(200); // Nose
  pg.triangle(225, 270, 250, 160, 275, 270);

  pg.fill(210); // Nostril
  pg.ellipse(240, 268, 16, 8);
  pg.ellipse(260, 268, 16, 8);

  pg.fill(220); // Mouth
  pg.rect(250, 300, 80, 4);

  pg.fill(230);   // Neck
  pg.rect(180, 440, 5, 100);
  pg.rect(320, 440, 5, 100);

  pg.fill(240); // Hair
  pg.ellipse(250, 85, 200, 70);

  pg.endDraw();
}


